<?php

require_once '../../core/backend.php';

require_once '../common/Api.php';
require_once '../common/Db.php';

require_once 'TouristAttractionModel.php';
require_once 'TouristAttractionApi.php';

$httpAuthToken = $savvyext->cfgReadChar('system.oauth2_token');

header("Access-Control-Allow-Origin: *");
header("Access-Control-Expose-Headers: Access-Control-Allow-Origin");
header("Access-Control-Allow-Headers: Cache-Control, Pragma, Origin, Authorization, Content-Type, X-Requested-With, client_id");
header("Access-Control-Allow-Methods: POST, GET, PUT, DELETE, OPTIONS");
header('Content-type: application/json');

if ("OPTIONS" === $_SERVER['REQUEST_METHOD']) {
    exit();
}

$headers = getallheaders();
if ((!isset($headers["Authorization"]) || substr($headers["Authorization"], -strlen($httpAuthToken)) != $httpAuthToken) &&
    (!isset($headers["authorization"]) || substr($headers["authorization"], -strlen($httpAuthToken)) != $httpAuthToken)) {
    header('HTTP/1.1 401 Unauthorized');
    header('Status: 401 Unauthorized');
    echo "{\"status\":\"Missing authorization\"}";
    exit();
}

try {
    if (strpos($_SERVER['REQUEST_URI'], '/api/') === false) {
        throw new Exception("Invalid API request");
    }
    $requestUri = explode('/', trim($_SERVER['REQUEST_URI'], '/'));
    while (array_shift($requestUri) !== 'api') {
    };

    if ($requestUri[0] == 'touristattraction') {
      $api = new TouristAttractionApi($requestUri, false);
    }
    echo $api->run();
} catch (Exception $e) {
    echo json_encode(array('error' => $e->getMessage()));
}


/**
 * @OA\Info(
 *   title="Geofence Area City Endpoint API",
 *   version="1.0",
 *   @OA\Contact(
 *     email="support@float.sg"
 *   )
 * )
 */
/**
 * @OA\SecurityScheme(
 *   securityScheme="token",
 *   type="apiKey",
 *   name="Authorization",
 *   in="header"
 * )
 */